% !TeX spellcheck = en_US
% !TeX encoding = UTF-8
% !TeX root = ../report.tex

\chapter{Guardian Angel via Finite Trajectory Set Evaluation}
\label{chp:ga_discrete_traj_set}


Among all the possible Guardian Angels that one could devise - some of them can be found in \Cref{sec:Related_work} - the decision was made to implement the Guardian Angel in the following way: We define a (fixed) set of input sequences (a so-called scenario) which is applied to the gokart at the current state and the state propagated with the controller input yielding different trajectories. If none of the trajectories starting at the  propagated state \textit{safe} with respect to some metric, the Guardian Angel triggers a sequence of \textit{safe} commands overriding the commands of the Agent.

We chose this approach because of its relatively simple implementation and that no optimizer is needed in to find the optimal trajectory while still maintaining recursive feasibility. Since we are using the Guardian Angel in parallel to the main controller, it has to be as lightweight as possible. That is why we use an approach similar to~\cite{Liniger} with a reduced count of trajectories while adapting their approach to also work within a non-static environment. Furthermore, we modified the idea of a safety filter (from~\cite{tearle2021predictive}) to a safety filter running in parallel to the main system in order to reduce the induced delay. 

Our implementation of the Guardian Angel thus is an anytime algorithm that is not complete since it intervenes for all cases where there exists a safe trajectory that is not part of our finite set. By selecting a variety of different "{}reasonable"{} sets of inputs,false interventions are minimized. Extending this approach by \textit{trusting the Agent's plan} (see \Cref{chp:ga_with_plan}) this problem can further be mitigated.


\paragraph{Overview} As visible in \Cref{fig:ga_internal}, the Guardian Angel consists of the following building blocks:
\begin{itemize}
    \item \textbf{Occupancy grid}, a live representation of obstacles on a map of discrete squares. (See more in \Cref{chp:OccupancyGridChapter}.)
    \item \textbf{Localization}, finding the current state of the gokart from the observations.
    \item \textbf{Forward propagation}, taking the set of input sequences and a mathematical model in order to calculate the predicted trajectories corresponding to each scenario.
    \item \textbf{Scoring}, evaluation of the trajectories based on its path and the occupancy grid.
    \item \textbf{Intervention Logic}, deciding whether the current inputs can be considered save and, if not, selecting the best commands in order to stop the gokart.
\end{itemize}

\begin{figure}[ht]
\centering
\scalebox{0.75}{
    \input{tikz/Guardian_Angel_Internals}
}
\caption{Internal working of the Guardian Angel}
\label{fig:ga_internal}
\end{figure}


\section{Binary Occupancy Grid}
The task of the occupancy grid is to determine whether a certain point in space is an obstacle or not. A more in-depth explanation can be found in \Cref{chp:OccupancyGridChapter}. A binary occupancy grid is a function mapping a pose to a boolean value which is True when an obstacle can be found at the given position. 
\begin{align}
    \occupancyGrid: \SE{2} \to \bools
\end{align}
We will use this function in order to evaluate the safety of various trajectories.

% \section{Localization}
% \az{remove section}
% The localization extracts the current gokart state $\gokartState$ from the current point cloud $\pointcloud$ given an initial assumption using a SLAM-approach.
% \begin{align}
%     \locFunc: \pointcloud \xrightarrow{} \gokartState
% \end{align}


\section{System Modeling}
Both the formulas of the Model and the Brake- and Motors interface have been developed Marc Heim~\cite{MTMarcHeim} and were further improved by the work of Christoph Demuth~\cite{SPChristoph}. As the new Model has not been implemented yet, Marc's Model is still in use for all plots visible in this thesis. The same model is also used in the current implementation of the MPCC.

\subsection{Gokart Model}
The gokart state $\gokartState$ consists of $[x, y, \theta, v_x, v_y, \dot \theta]^T$, its pose in with respect to the global frame $\gokartPosition$ and the velocity in gokart frame $\gokartVelocity$. The input into the model $\gokartInput$ is formed by $[AB_L, AB_R, \beta]^T$, the acceleration of the left and right wheel plus the angle of the steering wheel. The \textit{dynamics}-function $\dynFunc$ defines the connection between $\gokartInput$ and the state $\gokartState$: $\dot\gokartState = \dynFunc(\gokartState, \gokartInput)$.

The model from~\cite{MTMarcHeim} is based on the bicycle model but - since the gokart is capable of torque vectoring on the back axle- is extended to a tricycle model. Furthermore this model uses Pacejka's magic formula~\cite{Pacejka2012} to model tyre slip. It calculates the forces on the tyres of the tricycle and then deduces the accelerations $[\dot{v_x}, \dot{v_y}, \ddot \theta]^T$ from them.

\paragraph{Note,} the model that is used throughout the thesis relies on the Tricycle model with above mentioned states and inputs. However this does not affect generality and all described approaches work for any model with various definitions of state and input. 

\subsection{Motors- and Brakes-Interface}
The gokart model, resp. Brake- and Motors interface, provide functions that map the current state and the gokart input to the respective longitudinal acc-/deceleration $\longacc$. $\pThrottle \in [-1, 1]$ and $\pBrakes \in [0, 1]$ denote the position of the brake resp. the percentage of the maximal current requested from the motors, $A_{max}$ depicts the maximum deliverable current. 
\begin{align}
    \text{Motors-Interface: } \longacc = \motorsIF \left( \gokartState, \pThrottle \cdot A_{max} \right)\\
    \text{Brakes-Interface: } \longacc = \brakesIF \left( \gokartState, \pBrakes \right)
\end{align}

\begin{figure}[ht]
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/mappings/motor_if_.png}
    \caption{Motors-Interface}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/mappings/motor_if_top.png}
    \caption{Motors-Interface, top-view}
  \end{subfigure}
  
  \medskip
  
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/mappings/brake_if_.png}
    \caption{Brake-Interface}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/mappings/brake_if_top.png}
    \caption{Brake-Interface, top-view}
  \end{subfigure}

\end{figure}


\subsection{Model Validation}
In order to test the reliability of our model, we used a recording of the MPCC running at various speeds, extracted the commands and states with the respective timestamps. Some equally spaced points in time were selected, the corresponding state is considered as the starting point. Furthermore all future inputs for set amount of time are used to simulate the trajectory using the implemented model. This trajectory (red) is then compared to actual trajectory taken by the gokart (green) in \Cref{fig:ModelValidation}.

\begin{figure}[h!t]
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/model_validation/mpcc_2_offs_6.png}
    \caption{MPCC Controller @$v\approx2 m/s$}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/model_validation/mpcc_4_offs_6.png}
    \caption{MPCC Controller @$v\approx4 m/s$}
  \end{subfigure}

  \medskip
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/model_validation/mpcc_5_offs_6.png}
    \caption{MPCC Controller @$v\approx5 m/s$}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/model_validation/mpcc_6_offs_6.png}
    \caption{MPCC Controller @$v\approx6 m/s$}
    \label{fig:ModelValidation6}
  \end{subfigure}

  \medskip
  \begin{subfigure}[t]{\textwidth}
    \centering
    \includegraphics[width=.5\textwidth]{images/model_validation/mpcc_7_offs_6_optimizer.png}
    \caption{Optimized Pacejika parameters @$v\approx7 m/s$}
    \label{fig:better_pacej}
  \end{subfigure}
  
  \caption{Model (red) vs real system (green)}
  \label{fig:ModelValidation}
\end{figure}

As visible in \Cref{fig:ModelValidation} the models provides a good estimation until an average speed of 4m/s, at higher speed the model lacks accuracy especially in the corners. Furthermore drifting is not captured to well by the model.

Using a multivariate optimizer, we improved the Paceijka parameters of the open loop simulation and reached the result visible in \Cref{fig:better_pacej}. This particular picture comes from an MPCC running at $\approx7m/s$ average lap time. The average RSME of the prediction improved by $18\%$ compared to the old parameters.

\clearpage
\section{Scenarios and Trajectory Set Generation}
In contrast to~\cite{tearle2021predictive} we did not formulate the problem of finding the best possible trajectory as an MPC-problem since this would result in a computationally intensive Guardian Angel. Similar to~\cite{Liniger} we only select a set of trajectories. These trajectories are calculated from a set of predetermined, timestamped inputs, so-called scenarios.
\subsection{Scenario}
A scenario defines a set of inputs and is modeled as a function $\scenFunc$ which maps the current gokart state $\gokartState$ to a set of future inputs of the gokart $\gokartInput$. $\Delta t$ Denotes an arbitrary spacing on when to apply the commands with respect to the current time.
\begin{align}
    \text{scenario}: \gokartInput_{\mathrm{scenario}}(t) &=  \scenFuncFull\\
             &=  \left\{             
            \langle t,         \gokartInput_{\mathrm{sc_0}}\rangle,
            \langle t+\Delta t, \gokartInput_{\mathrm{sc_1}}\rangle,
            \langle t+2\Delta t, \gokartInput_{\mathrm{sc_2}}\rangle, 
            \dots
    \right\}
\end{align}

\subsubsection{Scenario Generation}
For the initial setup, the prediction uses several static scenarios with various delays. Static in the sense that they are always applied in the same way, independently of any outer constraints (e.g. the Occupancy Grid). Thus it is only a function of the current state, the time and the current input. The delay is implemented as stated in  \Cref{eq:staticScenariosDef}, applying the old command for its duration. The set of all scenarios $\setS$ is defined as the scenario with $\gokartInputStatic$ being every element of the combination of all selected inputs. 
\begin{align}
    \scenFuncStaticFullIpt &= \begin{cases}
        \gokartInput_{previous}  & \text{if $t < \tDelay$}\\
        \gokartInputStatic    & \text{else}
    \end{cases}\label{eq:staticScenariosDef}\\
    \gokartInputStatic(\gokartState(t)) &\in \{\gokartInput_{s_1}(\gokartState(t)), \gokartInput_{s_2}(\gokartState(t)), \dots\} = \\
    &=\left\{\left(0, 0\right), \left(AB_{R_{min}}\left(\gokartState\left(t\right)\right), AB_{L_{min}}\left(\gokartState\left(t\right)\right)\right)\right\} \cross \{-\beta, 0, \beta\}\label{eq:staticScenariosSet}\\
    \tDelay & \in \left\{t_1, t_2, \dots\right\} \\ 
    \setS &= \scenSet, \text{ where } \scenFunc_i =\scenFuncStatic\left(\gokartState(t),t, t_{i}, \gokartInput_{s_i} \right)
\end{align}
Note that $AB_{R_{min}}$ in \Cref{eq:staticScenariosSet} denotes the minimal acceleration, i.e. the maximum deceleration. In a randomly selected state the scenarios yield the following trajectories using the predictions introduced in \Cref{subs:predictions} visible in \Cref{tab:scenarios_expl}. 

\begin{table}[htb]
	\centering
	\adjustimage{height=4cm,valign=c}{images/expl_scenarios/Lines.png}\quad%
	\begin{tabular}{ll}
	    \colBox{rvizLightGreen} & $\gokartInput_{s_1} = (0, 0, 0)$\\
        \colBox{rvizDarkGreen} & $\gokartInput_{s_2} = (0, AB_{L_{min}}, AB_{R_{min}})$\\
        \colBox{rvizLightBlue} & $\gokartInput_{s_3} = (-\beta, 0, 0)$\\
        \colBox{rvizDarkBlue} & $\gokartInput_{s_4} = (-\beta, AB_{L_{min}}, AB_{R_{min}})$\\
        \colBox{rvizPink} & $\gokartInput_{s_5} = (\beta, 0, 0)$ \\ 
        \colBox{rvizRed} & $\gokartInput_{s_6} = (\beta, AB_{L_{min}}, AB_{R_{min}})$
	\end{tabular}
	\caption{Brake Scenarios at different delays}
    \label{tab:scenarios_expl}
\end{table}

%\todo[inline]{Here you want to show that all the scenarios that you consider have good ``coverage'' properties for all the states (different speeds and steering conditions). Need to have some kind of dispersion score}

\paragraph{Selection of scenarios}
Should the Guardian Angel intervene, we want it to first and foremost stop the kart in a safe way, as fast as possible. Furthermore - according to \Cref{sec:ga_proof} - stopping is required to guarantee a safe escape trajectory in a static environment. That is why we are using scenarios with a negative motor-acceleration and applied brakes. Torque-vectoring would complicate matters while having only a small effect in braking, so it is not in use ($\xrightarrow{} AB_{R_{min}} = AB_{L_{min}} = AB_{min}$). As it is dependant on the current state of the gokart, $AB_{min}$ is calculated as follows: 
\begin{align}
    AB_{min}\left(\gokartState(t)\right) = \motorsIF\left(\gokartState(t), -1 \cdot A_{max}\right) + \brakesIF\left(\gokartState(t), 1\right)
\end{align}
Extreme steering wheel angles (above $1.0$) proved to be hard to reach reliably by the steering controller and yielded very inconsistent results in the simulation since no exact model of the steering wheel column exists yet (see \Cref{chp:Discussion}). The trajectory belonging to too large of a steering wheel angle furthermore ends up within the track barriers since the kart cannot brake fast enough. Too small of a steering angle is not enough to reliably avoid the obstacle. Selecting the steering wheel angle $\beta = 0.8$ proved a reasonable compromise, as it is easily reachable, and even on the most narrow tracks, the gokart manages to brake before hitting the track barrier.

Experiments showed that under certain conditions, it is more favorable to use the last controller command and let the gokart roll out without using the brake. Therefore three additional scenarios were created with zero acceleration on the wheels (apart from friction), adding the tuple $(0, 0)$ to the list of possible accelerations.

\subsection{Predictions}\label{subs:predictions}
The trajectory (evolution of states) is calculated using a open-loop \textit{prediction} by integrating over the system dynamics for a given set of inputs (which are based on a given scenario).
\begin{align}
    \gokartState_t =\int _{t_{0}}^{t_N} \dynFuncFull dt, \text{where } \gokartInput(t) = \scenFuncFull, t_0 = 0
\end{align}
A trajectory is defined as a timestamped set of states:
\begin{align}
    \gokartStates &= \gokartStateSetTime = \gokartStateSet, \text{where }\\
    \gokartState_0 &= \text{current state}, \gokartState_k = \text{predicted state of the gokart at time $t_k$}
\end{align}
The Prediction function $\predFunc$ maps a given initial state $\gokartStateInit$ and a given set of inputs $\gokartInputs$ to a set of predicted states $\gokartStates$ (i.e. the trajectory) using the dynamics function from above.
\begin{align}
    \predFunc: (\gokartStateInit, \gokartInputs) \mapsto \gokartStates
\end{align}
For a Scenario $\scenFunc$, $\gokartInputs$ itself can be a function of the current state and time. Using a recursive approach the trajectory is calculated as follows:
\begin{align}
    \predFuncScen&: (\gokartStateInit, \gokartInput_{prev},\scenFuncStatic, d) \mapsto \gokartStates \\
    \gokartState_{k+1}&= \predFunc \left(\gokartState_k, \left\{\scenFuncStatic(\gokartState_k, t_k, d, \gokartInput_{prev})\right\}\right)\\
    \Rightarrow \gokartStates &= \gokartStateSet
\end{align}


\subsection{Trajectory Set Generation}
The set of all scenarios $\setS$ is evaluated for a set of delays $\gokartDelays = \gokartDelaySet$, yielding the set of trajectories $\trajectorySet$. Furthermore the set of Trajectories $\trajectorySet_{\controllerSubs}$ after applying the input $\gokartInputCtrl$ is calculated. 
\begin{alignat}{3}
    &\trajectorySet &&= \left\{\trajectory_1, \trajectory_2, \dots \right\} &&= \left\{\predFuncScen\left( \gokartStateInit, \gokartInput_{prev}, \scenFunc, d\right) \forall \scenFunc, \gokartDelay \in (\setS \times \gokartDelays) \right\}\\
    &\gokartStateCtrl &&=  &&= \predFunc\left(\gokartStateInit, \{\gokartInputCtrl\} \right)\label{eq:controller_state_scen}\\ 
    &\trajectoryCtrlSet &&= \dots &&= \left\{\predFuncScen\left( \gokartStateCtrl, \gokartInputCtrl, \scenFunc, d\right) \forall \scenFunc, \gokartDelay \in (\setS \times \gokartDelays) \right\} \label{eq:controller_traj_scen}
\end{alignat}

\section{Trajectory Scoring}
To find out if any trajectory is safe - or - find the "{}least-worst"{} trajectory, a scoring-process consisting of a scoring function is applied to every trajectory in $\trajectoryCtrlSet$ and $\trajectorySet$.

\subsection{Scoring Function}\label{subs:scoring_fct}
A \emph{scoring function} is defined as a (mathematical) function of the trajectories and the occupancy grid, which calculates the cost $\costJ$ with respect to a specific metric. More arguments are possible but currently not in use. 

\begin{align}
    \costJ = \scoringFunction(\trajectory, \occupancyGrid)
\end{align}
% \todo[inline]{this signature does not really parse... what about J:}

\subsubsection{Examples of scoring functions}
\begin{itemize}
    \item \textbf{Impact velocity}
        \begin{align}
            \scoringFunctionArguments =
            \begin{cases}
                \gokartVelocity\left(\gokartState\right) & \text{if $\occupancyGrid\left(\gokartPosition\left(\gokartState\right) \right)$ and $\scoringFunction \neq 0$}\\
                0                       & \text{else}
            \end{cases} \forall \gokartState \in \trajectory
        \end{align}
    \item \textbf{Safety Margin}
        \begin{align}
            \scoringFunctionArguments = \sum_i \left|\gokartPosition_i\left(\gokartState\right) - \sigma\left(\gokartPosition_i\left(\gokartState\right), \occupancyGrid\right)\right|, \text{with $\sigma(\gokartPosition ,  \occupancyGrid)$ the closest obstacle point}
        \end{align}
    \item \textbf{Predictability} since the trajectory is harder to predict while drifting or at higher speed. 
        \begin{align}
            \scoringFunctionArguments = \sum_i \left|\gokartVelocity_y\left(\gokartState_i\right) \right|
        \end{align}
    \item ...
\end{itemize}
\subsection{Application}
\subsubsection{Combining scoring functions}

The final cost is then calculated as a weighted sum of all scoring functions \Cref{eq:traj_cost}. Should this not suffice, an activation function $\activationFunction$ (see \Cref{app:activationfcts}) can be applied.

\begin{align}
     \scoringFunctionTotal\left(\trajectory, \occupancyGrid \right)= \sum_i \alpha_i\cdot \activationFunction{_i} \left(\scoringFunction{_i}\left(\trajectory, \occupancyGrid \right)\right) \label{eq:traj_cost}
\end{align}

The overall scoring function is then applied to every trajectory in $\trajectorySet$ and $\trajectoryCtrlSet$ in order to create two sets of cost. 

\begin{alignat}{3}
    &\costJs &&= \costJSet &&= \left\{ \scoringFunctionTotal(\trajectory, \occupancyGrid) \forall \trajectory \in \trajectorySet\right\}\\
    &\costJsCtrl &&= \dots &&= \left\{ \scoringFunctionTotal(\trajectory, \occupancyGrid) \forall \trajectory \in \trajectoryCtrlSet\right\}
\end{alignat}

\paragraph{Note}
Since  the gokart cannot be modeled only as a single point in space, we need to evaluate an area around the center of gravity at every point of the trajectory. Instead of doing so we dilate every obstacle of the occupancy grid $\occupancyGrid$ with a circle of radius $0.8m$. Thus we are effectively modeling the gokart as a circle with that radius. This optimization increases the evaluation of the trajectory considerably as we only have to check the center of gravity. An illustration can be found in \Cref{fig:mpcctrajectory_model_circle} and a comparison of the two above mentioned methods in \Cref{app:dil_vs_check}.


\section{Best Trajectory} \label{sec:best_tray}

The Guardian Angel always keeps track of the best trajectory at the current point in time (before applying the controller input), i.e. the scenario with the lowest cost $\costJ$.

\begin{align}
    \scenFunc_{\mathrm{best}} = \scenFunc_i \in \setS \text{ with } i = \argmin_{i}\costJ_i, \costJ_i \in \costJs
\end{align}

Should there be several scenarios with minimal cost $\costJ_i$, the Guardian Angel selects the first of these scenarios, i.e. minimizes $i$.

In a perfect world this scenario always has zero cost as proven in  \Cref{sec:ga_proof}. The "{}$\argmin$"{}-function covers this case as well as the one where no scenario with zero-costs exists due to the dynamic environment, modeling errors, misjudged calculation time, etc.

\section{Intervention Logic}

\begin{figure}[hbt!]
\centering
% \subimport{tikz}{Intervention_Logic.tikz}
    \input{tikz/Intervention_Logic.tex}
\caption{Scoring Function}
%\label{}
\end{figure}
The intervention logic decides when the Guardian Angel needs to intervene by overriding the Agent's commands. If the set of costs for each trajectory \textbf{after} the (simulated) controller input $\costJsCtrl$ does not contain at least one element with cost $\costJ = 0$, an intervention will be triggered. 
\begin{align}
    \begin{cases}
        \text{intervene} & \text{if $\costJ \neq 0 \forall \costJ \in \costJsCtrl$}\\
        \text{continue} & \text{otherwise}
    \end{cases}
\end{align}

The Guardian Angel will then take over with the commands belonging to the scenario with the lowest cost $\gokartInput(\scenFunc_{\mathrm{best}})$ from \Cref{sec:best_tray}.


\clearpage
\section{Proof of the Existance of a Safe Escape Trajectory} \label{sec:ga_proof}
In this section, a proof will be presented that the Guardian Angel will never collide with an obstacle, showing that the main idea of the Guardian Angel (to always have at least one safe escape route) is never violated. In other words, that the Guardian Angel as a safety filter is recursively feasible. Under the assumption of a static environment.

\paragraph{Assumptions}
\begin{enumerate}
    \item All obstacles remain static, i.e. the occupancy grid is time independent.
    \item The Model $\dot \gokartState(t) = \dynFuncFull$ is exact, hence no integration error in \\ $\gokartState(t_1) = \dynFuncFullInt{t_0}{t_1}$ occurrs either. \label{item:assumptions_ga_proof_exact_model}
    
    \item All given scenarios $\scenFunc \in \setS = \scenSet $ end at zero velocity $\extractVelocity(\gokartState_{\mathrm{scenario}_\mathrm{end}}) = \Vec{0}$ \label{item:assumptions_ga_proof}
    \item The interval of the Agent's inputs $T_{\controllerSubs}$ is known and constant.
    \item No delays while calculating in the GA occur.
\end{enumerate}

\paragraph{Notation}
For simplicity the proof will be done in discrete time steps, without loss of generality. Thus $\gokartState[0] = \gokartState_0, \gokartState[k] = \gokartState(k\cdot T_{\controllerSubs}), \gokartInput[k] = \gokartInput(k\cdot T_{\controllerSubs}), \dots, k \in \mathbb{N}$

\paragraph{Base Case} At the initial state $\gokartStateInit$ where $\extractVelocity(\gokartStateInit) = \Vec{0}$ there exists at least one scenario $\scenFunc_{safe_0} \in \setS$ leading to a stop (zero velocity) of the Gokart \textit{without a collision} (i.e. $\costJ(s_{safe_0}, \gokartStateInit) = 0$). 
\paragraph{Induction step} 
Given a state $\gokartState[k]$ with at least one safe scenario $\scenFunc_{safe_k}$ and an Agent's input $\gokartInput[k]$. We calculate the predicted state $\gokartStatePred$ and the scenario costs $\costJs_{pred}[k+1]$ as follows:
\begin{align}
    \gokartStatePred &= \dynFuncFullDisc\\
    \costJs_{pred}[k+1] &= \left\{\costJ(s, \gokartStatePred) \forall s \in \setS)\right\}
\end{align}
The input $\gokartInput[k]$ and thus $\gokartStatePred$ will be considered unsafe if no scenario from the predicted new state $\gokartStatePred$ with zero cost exists, i.e. $\costJ \neq 0 \forall \costJ \in \costJs_{pred}[k+1]$. The scenario $\scenFunc_{safe_k}$ will be selected at time $k$, overriding $\gokartInput[k]$ and yielding a \textit{safe} exit strategy for $\gokartState[k]$.

Under Assumption \ref{item:assumptions_ga_proof_exact_model} the prediction of the new state is exact, thus $\gokartState[k+1] = \gokartStatePred$. As the scenario $\scenFunc_{safe_k}$ will be selected if $\gokartStatePred$ is considered unsafe, the gokart will be transferred into a state $\gokartState_{safe_\infty} = \lim_{t \to \infty} \predFuncScen\left(\gokartState[k+1], \scenFunc_{safe_k}, t)$ with $\gokartVelocity(\gokartState_{safe_\infty}) = \Vec{0}$, the base case under Assumption \ref{item:assumptions_ga_proof}.

Hence, the state $\gokartState[k+1]$ will only be reached if $\gokartStatePred$ \textit{is} safe. Therefore the Guardian Angel will guarantee to always have a safe escape route - or intervene beforehand with the last safe commands if that could not be guaranteed. Which then leads to a safe stop.

\textit{Note:} This method will intervene at $\gokartState[k]$ if no $\scenFunc_{safe} \in \setS$ exist even though $\gokartStatePred$ is possibly a safe state in another scenario $\scenFunc \notin \setS$ compliant with Assumption \ref{item:assumptions_ga_proof}. 

\paragraph{Possible Extensions}
This proof can be extended for continuous time and variable controller interval $T_{\controllerSubs}$ without too much effort. The calculation time of the Guardian Angel can be modeled and included into $T_{\controllerSubs}$. These points are all considered in the current implementation of the Guardian Angel.

Furthermore the modeling errors can be quantified as a noise-function. $\dot \gokartState(t) = \dynFuncFull + \omega(t)$. However, this is beyond the scope of this thesis.

\section{Results}\label{sec:disc_res}
In this section we present the results we achieved with the Guardian Angel via a Finite Set of trajectories and compare it to what would have happened if a controller would have continued its unsafe plan.

\subsection{Setup}
To test the ability of the Guardian Angel we need a controller and an obstacle on the track unknown to the controller at the time of exploration. \Cref{fig:experimentsetup} shows a gymnastics ball with a diameter of $\approx0.6m$ as the obstacle to be avoided. As a controller we use the MPCC controller capped at various maximum velocities. This controller uses splines as track limits which have to be extracted on an exploration lap beforehand. Once these splines are determined, it does not consider any "{}new"{} obstacles.

\begin{figure}[ht]
    \centering
    \includegraphics[width=.7\textwidth, trim={200 100 200 100}, clip]{images/ga_output/Before_intervening.jpg}
    \caption{Experimental setup for a (yet) undiscovered obstacle}
    \label{fig:experimentsetup}
\end{figure}


\subsection{Scenarios}\label{subsec:scenarios_of_ga}

Table \ref{tab:scenarios} shows the scenarios which were in use during the tests. Please refer to Equation \ref{eq:staticScenariosDef} for the exact definition of a scenario. The delays are defined as $\gokartDelays = \left\{0.15, 0.4, 0.6\right\}$.

\begin{table}[hbt]
\centering
\resizebox{.9\textwidth}{!}{%
    \begin{tabular}{|c|l|r|r|r|r|} \hline
    \colBox{white}&          Name                       & $\beta$ & $\pThrottleL$ & $\pThrottleR$ & $\pBrakes$ \\ \hline\hline
    \colBox{rvizLightGreen}& \texttt{No\_Input}         & $0$     & $0$           & $0$           & $0.1$        \\ \hline
    \colBox{rvizDarkGreen}&  \texttt{Full\_Brake}       & $0$     & $-1$          & $-1$          & $1$        \\ \hline
    \colBox{rvizLightBlue}&  \texttt{Left}              & $0.8$   & $0$           & $0$           & $0.1$        \\ \hline
    \colBox{rvizDarkBlue}&   \texttt{Full\_Brake\_left} & $0.8$   & $-1$          & $-1$          & $1$        \\ \hline
    \colBox{rvizPink}&       \texttt{Right}             & $-0.8$  & $0$           & $0$           & $0.1$        \\ \hline
    \colBox{rvizRed}&        \texttt{Full\_Brake\_right}& $-0.8$  & $-1$          & $-1$          & $1$        \\ \hline
        \end{tabular}%
}
\caption{Definition of the scenarios currently in use}
\label{tab:scenarios}
\end{table}
As visible in  Equation \ref{eq:staticScenariosDef}, the static scenario requires the input $\gokartInputStatic$ - not \\$\left[\beta, \pThrottleL, \pThrottleR,\pBrakes\right]$, however given the current state $\gokartState_{curr}$ it can easily be calculated: 
\begin{align}
    AB_L &= \brakesIF \left( \gokartState_{curr}, \pBrakes \right) + \motorsIF \left( \gokartState_{curr}, \pThrottleL \cdot A_{max} \right)\\
    AB_R &=  \brakesIF \left( \gokartState_{curr}, \pBrakes \right) + \motorsIF \left( \gokartState_{curr}, \pThrottleR \cdot A_{max} \right)\\
    \xRightarrow{} \gokartInputStatic&= [AB_L, AB_R, \beta]
\end{align}
These scenarios (and delays) can easily be adjusted, should different scenarios be requested. For example, in the case of over-steering, a scenario that accelerates the motors first and then starts braking could be considered in order to take drifting into the barrier into account.

\subsection{Predictions}

\begin{figure}[ht]
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[height=.7\textwidth]{images/ga_output/mid_full.png}
    \caption{Braking before the corner}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[height=.7\textwidth, trim={0.45cm 0 0 0}, clip]{images/ga_output/mid_zoom.png}
    \caption{Braking before the corner, zoomed in}
  \end{subfigure}
  \medskip
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[height=.7\textwidth]{images/ga_output/right_full.png}
    \caption{Accelerating out of the corner}
    \label{fig:ga_output_right_full}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[height=.7\textwidth]{images/ga_output/right_zoom.png}
    \caption{Accelerating out of the corner, zoomed in}
    \label{fig:ga_output_right_zoom}
  \end{subfigure}
  \caption{Scenarios and predictions applied to different gokart states. \\For a detailed description of each scenario, refer to \Cref{subsec:scenarios_of_ga}}
\end{figure}

Let us take a closer look at the output of the Guardian Angel, which corresponds to \Cref{fig:ga_output_right_zoom}. Note that for better visibility, only the trajectories after the controller input are displayed. In \Cref{fig:ga_output_right_zoom} the trajectories are intentionally not cut off in contrast to the figure in \Cref{tab:scenarios_expl} to display the complete simulation for each trajectory.  Due to the high computational demands of plotting the trajectories, the calculation time is much higher than when in use without visualization (see \Cref{subsec:calc_time}).
\begin{verbatim}
[predictions_node-1] (0.10,      0.30,      0.60     ) <-- The delays
[predictions_node-1] ------------------------------------------------------
[predictions_node-1] (6.86/6.82, 6.86/6.82, 6.86/6.82) --> No_Input
[predictions_node-1] (0.00/0.00, 0.00/0.00, 0.00/0.00) --> Full_Brake
[predictions_node-1] (4.04/4.25, 4.18/4.25, 4.25/4.25) --> Left
[predictions_node-1] (0.00/0.00, 0.00/0.00, 0.00/0.00) --> Full_Brake_left
[predictions_node-1] (3.97/4.15, 3.99/4.15, 4.15/4.15) --> Right
[predictions_node-1] (0.00/0.00, 0.00/0.00, 0.00/0.00) --> Full_Brake_right
[predictions_node-1] safe, all good
[predictions_node-1] Best scenario: "Full_Brake" with overall cost 0.00
[predictions_node-1] Calculation time = 6693.00 µs, avg: 4.94 ms, std: 4.15 ms, 
    count: 452
\end{verbatim}
The Guardian angel calculates the scenario cost for each delay before and after the controller input \verb+x.xx/y.yy+, where \verb+x.xx+ is the cost for the trajectory \emph{before} the controller input $\costJ[k]$, i.e. the costs $\costJ_{pred}[k]$ from the previous step - given the gokart model is 100 percent correct. More interesting is the score \verb+y.yy+ which denotes the predicted costs $\costJ_{pred}[k+1]$ \emph{after} the input for each trajectory.

That \verb+No_Input+ does not yield a safe trajectory is visible in  \Cref{fig:ga_output_right_full}, the issues with \verb+Left+ and \verb+Right+ are clear by looking at \Cref{fig:ga_output_right_zoom}. Since there exists several scenarios with zero cost, the Guardian Angel does not need to react at all. Furthermore the Guardian Angel keeps track of the best scenario $\scenFunc_{best}$ - \verb+Full_Brake+ in that case - should an interruption be necessary in the next step. The calculation time will be discussed in the next section (\ref{subsec:calc_time}).

Lets take a look at a point in time, where the Guardian Angel interrupts the Agent:
\begin{verbatim}
[predictions_node-1] (0.10,      0.30,      0.60     ) <-- The delays
[predictions_node-1] ------------------------------------------------------
[predictions_node-1] (6.27/6.22, 6.27/6.22, 6.27/6.22) --> No_Input
[predictions_node-1] (3.04/6.22, 4.63/6.22, 6.27/6.22) --> Full_Brake
[predictions_node-1] (2.68/6.22, 5.72/6.22, 6.27/6.22) --> Left
[predictions_node-1] (0.00/6.22, 3.62/6.22, 6.27/6.22) --> Full_Brake_left
[predictions_node-1] (5.52/6.22, 5.88/6.22, 6.27/6.22) --> Right
[predictions_node-1] (2.96/6.22, 4.24/6.22, 6.27/6.22) --> Full_Brake_right
[predictions_node-1] safe, all good
[predictions_node-1] Best scenario: "Full_Brake_left" with overall cost 0.00
[predictions_node-1] Calculation time = 4506.00 µs, avg: 4.56 ms, std: 4.02 ms, 
    count: 259
[predictions_node-1]
[predictions_node-1] UNSAFE, ABORT
[predictions_node-1] Selecting scenario: "Full_Brake_left"
[predictions_node-1] running emergency scenario: "Full_Brake_left" at delay 0.10 s
[predictions_node-1] requesting ipt:  0.80 -1.00 -1.00  1.00 at delay 0.10s
[predictions_node-1] requesting ipt:  0.80 -1.00 -1.00  1.00 at delay 0.11s
[predictions_node-1] requesting ipt:  0.80 -1.00 -1.00  1.00 at delay 0.12s
[predictions_node-1] requesting ipt:  0.80 -1.00 -1.00  1.00 at delay 0.13s
...
[predictions_node-1] requesting ipt:  0.80 -1.00 -1.00  1.00 at delay 0.78s
[predictions_node-1] Stopped
\end{verbatim}

Corresponding images can be found in \Cref{ssec:IV_and_scen_sel}.

The Guardian Angel correctly detects that there exists no save trajectory after the controller input. Thus it interrupts with the last save scenario, \verb+Full_Brake_left+ at the only "safe" delay \verb+0.1+. After the delay has been reached, the Guardian Angel requests an input of $[\beta = 0.8, \pThrottleL = \pThrottleR = -1.0, \pBrakes=1.0]$ on safety-control-level overriding all controller commands. Once the current velocity is below a threshold ($0.1 m/s$) the Guardian Angel considers the gokart as \verb+Stopped+.

\subsection{Intervention and Scenario Selection}\label{ssec:IV_and_scen_sel}
As foreshadowed in \Cref{fig:experimentsetup}, the controller drives directly towards the obstacle and tends to hit the obstacle on the right side of the gokart as displayed in \Cref{fig:intervening_ga_before}. The Guardian Angel decides to intervene with the scenario \verb+Full_Brake_left+ which - after $0.15s$ - yields the situation visible in \Cref{fig:intervening_ga}. Another $0.8s$ later comes to a full stop without touching the ball or the track border, visible in \Cref{fig:intervening_ga_stopped}. 

\begin{figure}[ht]
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=.8\textwidth, trim={400 0 300 300}, clip]{images/ga_output/Before_intervening_close.jpg}
    \caption{GA not intervening}
    \label{fig:intervening_ga_before}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=.8\textwidth, trim={400 0 300 300}, clip]{images/ga_output/Intervening.jpg}
    \caption{$0.15 s$ after triggering an intervention }
    \label{fig:intervening_ga}
  \end{subfigure}
  \medskip
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=.8\textwidth, trim={400 0 300 300}, clip]{images/ga_output/Before_intervening_inbetween.jpg}
    \caption{$0.3 s$ after intervention}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[width=.8\textwidth, trim={700 0 0 300}, clip]{images/ga_output/stopped.jpg}
    \caption{Fully stopped ($0.95s$)}
    \label{fig:intervening_ga_stopped}
  \end{subfigure}
  \caption{Intervention procedure at $v\approx3.5m/s$}
\end{figure}

\clearpage
\section{GA-trajectory versus MPCC's Planned Trajectory}
In this section we compare the trajectory taken by the Guardian Angel and the path the MPCC wanted to take. As in \Cref{fig:experimentsetup} we used again a ball in the middle of the track. This time we take a look at the output of the modified occupancy grid in \Cref{fig:mpcctrajectory}. The ball is visible as the large obstacle in the middle of the track. Note that the occupancy grid has a resolution of $0.4\times0.4m$. \Cref{fig:mpcctrajectory} shows in yellow the planned path by the MPCC -\textbf{which is going right through the obstacle}- and in the other colors all precalculated trajectories. At that instant no trajectory after the controller input is evaluated as safe. Thus the Guardian Angel intervenes and selects the lime colored trajectory. Since these trajectories represent only the path of the center of gravity of the gokart, they stop some distance before the obstacle. Internally the Gokart is modeled as circle for efficiency reasons (see \Cref{subs:scoring_fct}). This circle is displayed in \Cref{fig:mpcctrajectory_model} and directly compared to the model of the actual gokart. In some areas (especially the sides) this approximation leads to a too conservative intervention.

\begin{figure}[!ht]
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[height=.75\textwidth, trim={50 0 150 0}, clip]{images/ga_output/MPCC_plan_intervention.png}
    \caption{Intended trajectory by the MPC $\xRightarrow{}$ \colBox{yellow} \\ Path taken by the GA:  $\xRightarrow{}$ \colBox{rvizLightGreen}}
    \label{fig:mpcctrajectory}
  \end{subfigure}
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[height=.75\textwidth, trim={300 200 270 150}, clip]{images/ga_output/MPCC_plan_intervention.png}
    \caption{\Cref{fig:mpcctrajectory}, closeup}
  \end{subfigure}
  \caption{MPCC trajecory vs. GA trajecory}
\end{figure}

\begin{figure}[ht]
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[height=.75\textwidth, trim={50 0 150 0}, clip]{images/ga_output/MPCC_plan_intervention_circle.png}
    \caption{Modeled shape of the gokart (Circle with \\radius $0.8m$) compared to a more exact model}
    \label{fig:mpcctrajectory_model}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.5\textwidth}
    \centering
    \includegraphics[height=.75\textwidth, trim={300 200 270 150}, clip]{images/ga_output/MPCC_plan_intervention_circle.png}
    \caption{\Cref{fig:mpcctrajectory_model}, closeup}
  \end{subfigure}
    \label{fig:mpcctrajectory_model_circle}
  \caption{Gokart Model, shape}
\end{figure}


% \begin{figure}[ht]
%   \begin{subfigure}[t]{.5\textwidth}
%     \centering
%     \includegraphics[width=.9\textwidth, trim={50 0 150 0}, clip]{images/ga_output/MPCC_plan_intervention.png}
%     \caption{Intended trajectory by the MPC $\xRightarrow{}$ \colBox{yellow} \\ Path taken by the GA:  $\xRightarrow{}$ \colBox{rvizLightGreen}}
%     \label{fig:mpcctrajectory}
%   \end{subfigure}
%   \begin{subfigure}[t]{.5\textwidth}
%     \centering
%     \includegraphics[width=.9\textwidth, trim={50 0 150 0}, clip]{images/ga_output/MPCC_plan_intervention_circle.png}
%     \caption{Modeled shape of the gokart (Circle with \\radius $0.8m$) compared to a more exact model}
%     \label{fig:mpcctrajectory_model}
%   \end{subfigure}
%   \begin{subfigure}[t]{.5\textwidth}
%     \centering
%     \includegraphics[width=.9\textwidth, trim={300 200 270 150}, clip]{images/ga_output/MPCC_plan_intervention.png}
%     \caption{\Cref{fig:mpcctrajectory}, closeup}
%   \end{subfigure}
%   \hfill
%   \begin{subfigure}[t]{.5\textwidth}
%     \centering
%     \includegraphics[width=.9\textwidth, trim={300 200 270 150}, clip]{images/ga_output/MPCC_plan_intervention_circle.png}
%     \caption{\Cref{fig:mpcctrajectory_model}, closeup}
%   \end{subfigure}
%   \caption{MPCC trajecory vs. GA trajecory}
% \end{figure}


\subsection{Calculation Time}\label{subsec:calc_time}
In order to keep the Guardian Angel as accurate as possible, it is crucial to keep the calculation time of the trajectories low. Various optimizations have been considered to optimize cache usage, vectorize calculations, and pre-allocate memory where ever possible. We identified the source of the most calculation-intensive part to be the generation of the ROS-Messages. Said messages contain the trajectories and need to be converted from an Eigen-Matrix to the vector-like structure of the ROS-Message marker-array. In order to display all trajectories in a "{}pretty"{} fashion and still fit them into one message, all trajectories have to be drawn twice, for- and backwards.

\begin{figure}[hbt!]
\centering
% \subimport{tikz}{Timing_Plots.tikz}
    \input{tikz/Timing_Plots.tex}
\caption{Calculation time for 6 scenarios}
\label{fig:timingPlots}
\end{figure}

Figure \ref{fig:timingPlots} displays calculation times for various optimizations. We implemented our approach is in C++ and run it with the same ROS-Bag on a 2.6GHz 2-Core CPU with 8GB RAM for all timing measures. $1$ is the time plotting every trajectory in a "{}pretty"{} way, in $2$, all plots have been cut once the trajectory intersects an obstacle. More optimization potential is to draw every trajectory only once ($3$) and not publishing any trajectories at all ($4$). Our ROS-node automatically chooses the last option if there is nothing subscribed to the respective topic. Using these optimizations, the calculation time of 6 trajectories à 3 delays can be reduced to approximately $3.5$ milliseconds. The CPU utilization of the Guardian Angel - including localization and occupancy grid which can be used by the Controller as well - is at \textbf{40 percent of one core}, while keeping the memory usage below 160MB, displayed in \Cref{fig:cpuutil}. (The gokart runs a 6-Core CPU with 16 GB of RAM.)


\begin{figure}[ht]
  \begin{subfigure}[t]{\textwidth}
    \centering
    \includegraphics[width=.85\textwidth, trim={1133 300 30 480}, clip]{images/ga_output/intervention logic.png}
    \caption{CPU Utilization on a single core}
  \end{subfigure}
  \begin{subfigure}[t]{\textwidth}
    \centering
    \includegraphics[width=.85\textwidth, trim={340 300 827 480}, clip]{images/ga_output/intervention logic.png}
    \caption{RAM Utilization}
  \end{subfigure}
  \caption{CPU Utilization}
  \label{fig:cpuutil}
\end{figure}


